-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--Oormi Tools v 0.2 
--July 2014
--By Oormi Creations 
--Web : http://oormi.in
--Email : oormicreations@gmail.com

--Description:
--
--These tools are a set of scripts useful for day-to-day work.
--This script is freeware and any kind of use and modification is allowed.

--Installation and use:
--
--Copy it in your 3ds max's scripts\startup folder to autostart at launch or simply run from menu.
--The script UI is in a form of toolbar and will dock at bottom. The buttons have tooltips. The buttons with a small red arrow at 
--bottom are with a right-click menu for settings/parameters etc.
--Supported versions: 3ds max 2011-2015

--Notes:
--
--Some settings like the image editor & logo filepath are saved on your disk so no need to set it everytime.
--You can change the docking etc by modifying this script.
--Please visit the above link for updates and more free scripts.
--Email any suggestions/bugs/errors/requests to us.
---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------


global OormiToolsRollout
savered = undefined
savegreen = undefined

fn OormiSaveNotification = 
(
-- 	print "OormiSaveNotification===Saved"
	nparam = callbacks.notificationParam()
	if nparam[1] == 1 then --catch only manual save
	(
		if savegreen!=undefined then OormiToolsRollout.btn30.images = #(savegreen, undefined, 1, 1, 1, 1, 1)
	)
)

clearlistener()

(
	



try 
(
	cui.UnRegisterDialogBar OormiToolsRollout
	DestroyDialog OormiToolsRollout
)
catch ()


alljpg = #()
alltif = #()
allgif = #()
allbmp = #()
alltga = #()
allpng = #()
alldds = #()

b		= undefined
alli 	= #()
count 	= 0
index 	= 1
logoposition = 6
logofile = undefined
vfblogo = undefined

cylsides = 8
gcolor = [88,88,88]
rallscale = 50
maxt = 12
assignalpha = off
assignsubmat = off
progpath = undefined
mshelppath = undefined

quadspsz = 10.0
quadspseg = 6
qs = undefined
qshemi = off
qswire = random (color 64 64 64) (color 200 200 200) 

quadcylinderrollout = undefined
qc = undefined
qcht=10.0
qcsz=5.0
qcseg=6
qcbias=1.5
qchtseg = 4
qctaper = 0.0
qccham = 1.0
qcchamseg = 4
qcwire = random (color 64 64 64) (color 200 200 200) 

rw1 = 64
rw2 = 200
rpselfillum = 100
rpcross = on
rprender = off

--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------

fn autosmoothall obj =
(
	psel = polyOp.getFaceSelection obj
	np = polyOp.getNumFaces obj
	polyop.setFaceSelection obj #{1..np} 
	obj.autosmooth()
	polyOp.setFaceSelection obj psel
)

fn createquadcylinder =
(
	try (delete qc)
	catch()
	with undo "QuadCylinder" on 
	(
		qcsz1 = qcsz*2/qcbias
		qc = 	plane width:qcsz1 length:qcsz1 lengthsegs:qcseg  widthsegs:qcseg
		qc.name = uniquename "QuadCylinder"
		qc.wirecolor = qcwire
		addmodifier qc (Normalmodifier flip:on)
		converttopoly qc
		select qc
		max modify mode
		subobjectLevel = 3
		max select all

		se = (polyOp.getVertsUsingEdge qc (polyop.getedgeselection qc)) as array
		for ver = 1 to ver = se.count do
		(
			newpos = (polyop.getvert qc se[ver])*scalematrix[qcbias,qcbias,qcbias]*(inverse qc.objecttransform)
			polyop.setvert qc se[ver] newpos
		)

		modPanel.addModToSelection (Spherify percent:100)
		converttopoly qc

		qcc = copy qc
		qcc.pos = [0,0,qcht]
		addmodifier qcc (Normalmodifier flip:on)
		converttopoly qcc
		qc.EditablePoly.attach qcc qc
		subobjectLevel = 3
		qc.bridgeSegments = qchtseg
		qc.bridgeTaper = qctaper
		qc.bridgeBias = 0.0
		qc.bridgeTwist1 = 0
		qc.bridgeTwist2 = 0
		qc.bridgeSelected = 1
		qc.EditablePoly.Bridge ()

		if qccham>0 then
		(
			qc.edgeChamferSegments = qcchamseg
			qc.edgeChamfer = qccham
			qc.edgeChamferOpen = off
			qc.EditablePoly.buttonOp #Chamfer
		)

		subobjectLevel = 0
		autosmoothall qc
		max zoomext sel all
	)
)


rollout quadcylinderrollout "QuadCylinder" width: 180 height:330
(
	label 	lbl1 "Radius" 					pos:[10,10] 
	label 	lbl2 "Height" 					pos:[10,40] 
	label 	lbl3 "Sides x 4" 				pos:[10,70] 
	label 	lbl4 "Height Segments" 		pos:[10,100] 
	label 	lbl5 "Cap Bias" 				pos:[10,130] 
	label 	lbl6 "Taper" 					pos:[10,160] 
	label 	lbl7 "Chamfer" 					pos:[10,190] 
	label 	lbl8 "Chamfer Segments" 	pos:[10,220] 
	
	spinner spn1 ""	pos:[110,10] 		width:50 height:25 range:[0.01,1000000,5] type:#float scale:0.1
	spinner spn2 ""	pos:[110,40] 		width:50 height:25 range:[0.01,1000000,10] type:#float scale:0.1
	spinner spn3 ""	pos:[110,70] 		width:50 height:25 range:[1,1000000,6] type:#integer
	spinner spn4 ""	pos:[110,100] 	width:50 height:25 range:[1,1000000,4] type:#integer
	spinner spn5 ""	pos:[110,130] 	width:50 height:25 range:[1,1000000,1.5] type:#float scale:0.01
	spinner spn6 ""	pos:[110,160] 	width:50 height:25 range:[-1000000,1000000,0] type:#float scale:0.01
	spinner spn7 ""	pos:[110,190] 	width:50 height:25 range:[0,1000000,1] type:#float scale:0.01
	spinner spn8 ""	pos:[110,220] 	width:50 height:25 range:[1,256,4] type:#integer
	
	button btnnew "Create New" pos:[15,260] width:150 height:30

	on quadcylinderrollout open do 
	(
		spn1.value = qcsz
		spn2.value = qcht
		spn3.value = qcseg
		spn4.value = qchtseg
		spn5.value = qcbias
		spn6.value = qctaper
		spn7.value = qccham
		spn8.value = qcchamseg
		qc = undefined
		qcwire = random (color 127 127 127) (color 200 200 200) 
		createquadcylinder()
	)
	
	on btnnew pressed do
	(
		qc = undefined
		qcwire = random (color 127 127 127) (color 200 200 200) 
		createquadcylinder()
	)
	
	on spn1 entered do
	(
		qcsz = spn1.value
		createquadcylinder()
	)
	on spn2 entered do
	(
		qcht = spn2.value
		createquadcylinder()
	)
	on spn3 entered do
	(
		qcseg = spn3.value
		createquadcylinder()
	)
	on spn4 entered do
	(
		qchtseg = spn4.value
		createquadcylinder()
	)
	on spn5 entered do
	(
		qcbias = spn5.value
		createquadcylinder()
	)
	on spn6 entered do
	(
		qctaper = spn6.value
		createquadcylinder()
	)
	on spn7 entered do
	(
		qccham = spn7.value
		createquadcylinder()
	)
	on spn8 entered do
	(
		qcchamseg = spn8.value
		createquadcylinder()
	)
	
)

fn GetOTConfig =
(
	otdir = getdir #plugcfg
	if otdir != undefined then
	(
		fini = otdir + "\\OormiTools.ini"
		--print fini
		if (doesFileExist fini) then
		(
			logofile = GetINISetting fini "OormiTools" "Logo"
			if logofile.count==0 then logofile = undefined
			progpath = GetINISetting fini "OormiTools" "IEditor"
			if progpath.count==0 then progpath = undefined
			mshelppath = GetINISetting fini "OormiTools" "MSHelp"
			if mshelppath.count==0 then mshelppath = undefined
			rw = GetINISetting fini "OormiTools" "RW1"
			if rw.count>0	then rw1 = rw as integer
			rw = GetINISetting fini "OormiTools" "RW2"
			if rw.count>0	then rw2 = rw as integer
		)
	)
)

fn SetOTConfig =
(
	otdir = getdir #plugcfg
	if otdir !=undefined then
	(
		fini = otdir + "\\OormiTools.ini"
		if (doesFileExist fini) then
		(
			if logofile!=undefined then SetINISetting fini "OormiTools" "Logo" logofile
			if progpath!=undefined then SetINISetting fini "OormiTools" "IEditor" progpath
			if mshelppath!=undefined then SetINISetting fini "OormiTools" "MSHelp" mshelppath
			SetINISetting fini "OormiTools" "RW1" (rw1 as string)
			SetINISetting fini "OormiTools" "RW2" (rw2 as string)
			--print "setini"
		)
		else
		(
			res = createFile fini
			if res != undefined then SetOTConfig()
			--print "created"
		)
	)

)

fn QuickLight =
(
	sp = targetSpot rgb:(color 255 255 255) target:(targetObject pos:[0, 0, 0])
	sp.raytracedShadows = on
	sp.baseObject.castShadows = on
	sp.pos = [200,-200,200]
	sp.multiplier = 0.65
	
	bk = copy sp
	bk.rgb = color 64 142 215
	bk.pos = [-40,200,70]
	bk.multiplier = 1.0
	

	sk = Skylight() 
	sk.castShadows = on
	sk.rays_per_sample = 12
	sk.pos = [0,0,200]
	sk.multiplier = 0.5
	
)


fn AssignTex btex =
(
	if btex != undefined then
	(
		if assignsubmat then
		(
			texname = getFilenameFile btex.filename
			mat = Standard()
			mat.name = $.name + "_MMat"
			mat.diffusemap = Bitmaptexture bitmap:btex
			showTextureMap mat on
			
			
			
			if classof $ == Editable_Poly then
			(
				if subobjectlevel >3 then
				(
					n = getfaceselection $
					if (n.isEmpty)==false then
					(
						if $.mat == undefined then
						(
							$.mat = Multimaterial()
							$.mat.materialList.count = 2
							$.mat.materialList[1] = mat
							$.mat.names[1] = texname
			
							polyOp.setFaceMatID $ n 1
							polyOp.setFaceMatID $ (-n) 2
							
						)
						if (classof $.mat) != Multimaterial then
						(
							oldmat = $.mat
							$.mat = Multimaterial()
							$.mat.materialList.count = 2
							$.mat.materialList[1] = oldmat
							$.mat.materialList[2] = mat
							$.mat.names[2] = texname
						)
						if (classof $.mat) == Multimaterial then
						(
							assignedid = undefined
							for i=1 to $.mat.materialList.count do
							(
								if (classof $.mat.materialList[i]) == Standardmaterial then
								(
									if (classof $.mat.materialList[i].diffusemap) == Bitmaptexture then
									(
										oldtex = $.mat.materialList[i].diffusemap.filename
										if oldtex==tex then assignedid = i
									)
								)
							)
							
							if assignedid == undefined then
							(
								$.mat.materialList.count += 1
								$.mat.materialList[$.mat.materialList.count] = mat
								polyOp.setFaceMatID $ n $.mat.materialList.count
								$.mat.names[$.mat.materialList.count] = texname
							)
							else polyOp.setFaceMatID $ n assignedid 
			
						)
					)
				)
			)

		)
		else
		(
			mat = Standard()
			mat.twoSided = on
			mat.diffusemap = Bitmaptexture bitmap:btex
			if assignalpha then
			(
				mat.opacitymap = Bitmaptexture bitmap:btex
				mat.opacitymap.monoOutput = 1
			)
			for obj in selection do 
			(
				obj.material = mat
				obj.material.name = obj.name + "_Mat"
				obj.material.diffusemap.name = obj.name + "_Difmap"
				if assignalpha then
				(
					obj.material.opacitymap.name = obj.name + "_Opamap"
				)
				
				showTextureMap mat on
	
				n=0
				for m in meditMaterials do 
				(
					n=n+1
					cm = classof m
					slot = true
					if cm != Standardmaterial then slot = slot and false 
					if slot==true then 
					(
						if m.diffuse != (color 150 150 150) then slot = slot and false
						if m.diffusemap != undefined 		then slot = slot and false 
						if m.opacitymap != undefined 		then slot = slot and false 
					)
					if slot==true then 
					(
						setMeditMaterial n mat
						exit
					)
				)
				
			)
		)
	)
)

fn RenameMat = 
(
	theDepNodes = #()
	
	for i = 1 to meditmaterials.count do
	(
		theDepNodes = (refs.dependents meditMaterials[i]) 
		for j = 1 to theDepNodes.count do
		(
			if superClassof theDepNodes[j] == GeometryClass do
			(
				--print theDepNodes[j].name
				meditMaterials[i].name = theDepNodes[j].name + "_Mat"
				if (classof meditMaterials[i])==Standardmaterial then
				(
					if meditMaterials[i].diffusemap !=undefined then meditMaterials[i].diffusemap.name = theDepNodes[j].name + "_Difmap"
					if meditMaterials[i].opacitymap !=undefined then meditMaterials[i].opacitymap.name = theDepNodes[j].name + "_Opmap"
				)
			)
		)
	)
	
)

fn RenderAllviews rscale =
(
	rscale = (rscale as float)/100.0
	if rscale == 0 then return()
	gap = 5*rscale
	bmp=#()
	
	for v = 1 to 4 do
	(
		viewport.activeViewport = v
		lab = viewport.getType() as string
		vsize = getViewSize()
		bmp[v]=bitmap (rscale*vsize.x) (rscale*vsize.y)
		render to:bmp[v]
	)
		
	a=bitmap (bmp[1].width + bmp[2].width + gap) (bmp[1].height + bmp[3].height + gap)
	n=a.height
	for v = 0 to 3 do
	(
		for nrow = 0 to n-1 do
		(
			row = getPixels bmp[v+1] [0,nrow] bmp[v+1].width 
			setPixels a [ (bit.and v 1)*(bmp[1].width+gap) , nrow + (bit.and v 2)*(bmp[1].height+gap)/2 ] row
			close bmp[v+1] -- comment this out if you want to keep all render windows
		)
	)
	
	display a
	bmp=undefined
)

fn InLogo = 
(
	bm = getLastRenderedImage()
	if bm == undefined then (max quick render)
	bm = getLastRenderedImage()
	--display bm
	logo = undefined
	if logofile == undefined then
	(
		logo = selectBitMap caption:"Select the Logo"
		if logo==undefined then return()
		logofile = logo.filename
		if logofile != undefined then SetOTConfig ()
	)
	else (logo = openBitMap logofile)
	if logo==undefined then return()
	
	--display logo
	if (bm.width<logo.width) or (bm.height<logo.height) then 
	(
		messagebox "Logo is bigger than the rendered image. Please select a small size logo image."
		return 0
	)
	
	pixel_array = #()
	logo_array = #()
	logopos_x = 10
	logopos_y = 10
	n = 0
	
	if logoposition==6 then (logopos_x = bm.width-logo.width-10; logopos_y = bm.height-logo.height-10)
	if logoposition==5 then (logopos_x = (bm.width-logo.width)/2; logopos_y = bm.height-logo.height-10)
	if logoposition==4 then (logopos_x = 10; logopos_y = bm.height-logo.height-10)
	if logoposition==3 then (logopos_x = bm.width-logo.width-10; logopos_y = 10)
	if logoposition==2 then (logopos_x = (bm.width-logo.width)/2; logopos_y = 10)

	
	
	bmex = logopos_x + logo.width  - 1
	bmey = logopos_y + logo.height - 1
	
	if bmex > bm.width  then bmex = bm.width
	if bmey > bm.height then bmey = bm.height
	
	for i = logopos_y to bmey do 
	(
		pixel_array = getPixels bm [0,i] bm.width
		logo_array = getPixels logo [0,n] logo.width
		
		for j = logopos_x to bmex do
		(
			lpx = logo_array[j - logopos_x + 1]
			bpx = pixel_array[j+1]
			lmul = (logo_array[j - logopos_x + 1].a / 255.)
			bmul = (1 - (logo_array[j - logopos_x + 1].a / 255.))
			
			pixel_array[j+1] = lpx * lmul + bpx * bmul
		)
		n += 1
		setPixels bm [0,i] pixel_array
	)

	try (undisplay vfblogo)
	catch()	

	display bm--refresh it
	vfblogo = bm
	
)


fn Editimage =
(
	obj = selection[1]
	if obj == undefined then 
	(
		if b==undefined then return()
		imagefile = b.filename
	)
	else
	(
		if obj.mat == undefined then (messagebox "Selected Object has no material"; return())
		if (classof obj.mat) != Standardmaterial then (messagebox "Only Standard material supported"; return())
		diff = obj.mat.diffusemap
		if (classof diff) != Bitmaptexture then (messagebox "Selected Object has no Bitmap texture"; return())
		
		imagefile = diff.filename
		--print imagefile 
	)
	
	res=doesFileExist imagefile
	if res==false then (messagebox "The image file was not found"; return())


	if progpath == undefined then
	(
		progpath = getOpenFileName filename:"C:\\Program Files\\Adobe\\*.exe" caption:"Select an image editor" types:"Application(*.exe)|*.exe|All Files|*.*|"
		if progpath != undefined then SetOTConfig()

	)
	if progpath == undefined then return()
	

	res = false
	if imagefile != undefined then
	(
		res = shelllaunch progpath imagefile
	)
	if res==false then messagebox "Could not open the texture/image for editing"
)

fn mshelplaunch =
(
	if mshelppath == undefined then
	(
		mshelppath = getOpenFileName filename:"" caption:"Select MS Help File" types:"Help File(*.chm)|*.chm|Htm File(*.htm)|*.htm|Html File(*.html)|*.html|All Files|*.*|"
		if mshelppath != undefined then SetOTConfig()
	)
	if mshelppath == undefined then return()
	

	res = false
	if mshelppath != undefined then
	(
		res = shelllaunch mshelppath ""
	)
	if res==false then messagebox "Could not open the help file"
)

--------------------------------------------------------------------------------------------------------------------------------------

rollout rpset "Reference Plane" width: 170 height:90
(
	label 	lbl1 "Self Illumination" 	pos:[10,10] 
	spinner spn1 ""	pos:[100,10] 	width:50 height:25 range:[0,100,100] type:#integer
	checkbox chkcross "Cross Planes" 
	checkbox chkren "Renderable" 

	on rpset open do 
	(
		spn1.value = rpselfillum
		chkcross.checked = rpcross
		chkren.checked = rprender
	)
	
	on spn1 entered do
	(
		rpselfillum = spn1.value
	)
	on chkcross changed state do 
	(
		rpcross = chkcross.checked
	)
	on chkren changed state do 
	(
		rprender = chkren.checked
	)

)


fn createquadsphere = 
( 
	with undo "QuadSphere" on 
	(
		try (delete qs)
		catch()
		qs=box height:quadspsz width:quadspsz length:quadspsz lengthsegs:quadspseg  widthsegs:quadspseg heightsegs:quadspseg
		qs.wirecolor = qswire
		addmodifier qs (Spherify PERCENT:100)
		converttopoly qs
		CenterPivot qs
		qs.pos = [0,0,0]
		if qshemi then
		(
			nv = polyop.getNumVerts qs
			for v=1 to nv do
			(
				pos = polyop.getVert qs v
				if pos.z < 0 then polyop.setVert qs #{v} [pos.x,pos.y,0] 
			)
		)
		autosmoothall qs
		qs.name = uniquename "QuadSphere"
		select qs
		max zoomext sel all
	)
)



rollout quadspheresettings "QuadSphere" width: 120 height:140
(
	label 	lbl1 "Iterations" 	pos:[10,10] 
	label 	lbl2 "Diameter"		pos:[10,40] 
	spinner spn1 ""				pos:[60,10] 	width:50 height:25 range:[1,256,6] type:#integer
	spinner spn2 ""				pos:[60,40] 	width:50 height:25 range:[1,1000000,10] type:#float scale:0.1
	
	checkbox chkhemi "Hemisphere" 
	button btnnew "Create New" pos:[10,100] width:100 height:30

	on quadspheresettings open do 
	(
		spn1.value = quadspseg
		spn2.value = quadspsz
		qs = undefined
		qswire = random (color 64 64 64) (color 200 200 200) 
		createquadsphere()
	)
	
	on spn1 entered do
	(
		quadspseg = spn1.value
		createquadsphere()
	)
	on spn2 entered do
	(
		quadspsz = spn2.value
		createquadsphere()
	)
	on btnnew pressed do
	(
		qs = undefined
		qswire = random (color 64 64 64) (color 200 200 200) 
		createquadsphere()
	)
	on chkhemi changed state do 
	(
		qshemi = chkhemi.checked
		createquadsphere()
	)

)



rollout logoset "Position" width:75 height:75
(
	checkbutton cb1 "TL" pos:[ 0,  0] width:25 height:25 tooltip:"Top Left" --images:#(bm1, undefined, 1, 1, 1, 1, 1)
	checkbutton cb2 "TM" pos:[25,  0] width:25 height:25 tooltip:"Top Mid" --images:#(bm1, undefined, 1, 1, 1, 1, 1)
	checkbutton cb3 "TR" pos:[50,  0] width:25 height:25 tooltip:"Top Right" --images:#(bm1, undefined, 1, 1, 1, 1, 1)
	checkbutton cb4 "BL" pos:[ 0, 25] width:25 height:25 tooltip:"Bottom Left" --images:#(bm1, undefined, 1, 1, 1, 1, 1)
	checkbutton cb5 "BM" pos:[25, 25] width:25 height:25 tooltip:"Bottom Mid" --images:#(bm1, undefined, 1, 1, 1, 1, 1)
	checkbutton cb6 "BR" pos:[50, 25] width:25 height:25 tooltip:"Bottom Right" --images:#(bm1, undefined, 1, 1, 1, 1, 1)
	button btn1	"Select" pos:[ 0, 50] width:75 height:25 tooltip:"Select the logo file"
	
	local cb = logoset.controls
	fn setchk n = 
	(
		for i=1 to 6 do (if classof cb[i]==CheckButtonControl then cb[i].checked=off)
		if classof cb[n]==CheckButtonControl then 
		(
			cb[n].checked = on
			logoposition = n
		)
	)
	on cb1 changed s do (setchk 1)
	on cb2 changed s do (setchk 2)
	on cb3 changed s do (setchk 3)
	on cb4 changed s do (setchk 4)
	on cb5 changed s do (setchk 5)
	on cb6 changed s do (setchk 6)
	on logoset open  do 
	(
		setchk logoposition
		if logofile != undefined then btn1.text = filenameFromPath logofile
	)
	on btn1 pressed do
	(
		logo = selectBitMap caption:"Select the logo"
		if logo != undefined then
		(
			logofile = logo.filename
			SetOTConfig()
			btn1.text = filenameFromPath logofile
		)
	)
)

rollout cylset "Sides" width:50 height:17
(
	spinner spn1 ""	pos:[0,0] width:50 height:25 type:#integer range:[3,128,8]
	on spn1 changed val do cylsides = val
	on cylset open do spn1.value = cylsides
)

rollout groundcol "Color" width:50 height:17
(
	colorpicker col1 "" pos:[0, 0] width:50 height:17 color:gcolor
	on col1 changed val do gcolor = val
	on groundcol open do col1.color = gcolor
)

rollout rallview "Scale" width:50 height:17
(
	spinner spn1 ""	pos:[0,0] width:50 height:25 type:#integer range:[1,1000,50]
	on spn1 changed val do rallscale = val
	on rallview open do spn1.value = rallscale 
)

rollout rwset "Random Wirecolors" width:170 height:120
(
	slider sld1 "Colors Lower Range:     64" pos:[10,10] width:160 height:44 ticks:10 range:[0,255,64]
	slider sld2 "Colors Upper Range:   200" pos:[10,60] width:160 height:44 ticks:10 range:[0,255,200]
	
	on sld1 changed val do
	(
		rw1 = val as integer
		sld1.text = "Colors Lower Range:   " + (rw1 as string)
	)
	on sld2 changed val do
	(
		rw2 = val as integer
		sld2.text = "Colors Upper Range:   " + (rw2 as string)
	)

 	on rwset open do 
	(
		sld1.value = rw1
		sld2.value = rw2
		sld1.text = "Colors Lower Range:   " + (rw1 as string)
		sld2.text = "Colors Upper Range:   " + (rw2 as string)
	)
 	on rwset close do 
	(
		SetOTConfig()
	)
)

rollout texset "Set" width:25 height:50
(
	checkbutton cb1 "ALP" pos:[0, 0] width:25 height:25 tooltip:"Assign alpha as opacity" --images:#(bm1, undefined, 1, 1, 1, 1, 1)
	checkbutton cb2 "SUB" pos:[0,25] width:25 height:25 tooltip:"Assign to subobject" --images:#(bm1, undefined, 1, 1, 1, 1, 1)
	on texset open  do 
	(
		cb1.checked = assignalpha; 
		cb2.checked = assignsubmat
		try
		(
			tb=bitmap 25 25
		cb1.images = #((load_bitmap_alpha2()), tb, 2, 1, 2, 1, 1)
		cb2.images = #((load_bitmap_subm2()), tb, 2, 1, 2, 1, 1)
		)
		catch()
	)
	on cb1 changed s do (assignalpha = s)
	on cb2 changed s do (assignsubmat = s)
)

rollout OormiToolsRollout "    O o r m i - T o o l s" width:1080 height:25
(
	button btn3  "Open" 	pos:[  0, 0] width:27 height:27 tooltip:"Open an image or sequence or video\n(Right Click to clear)" border:off
	button btn2  "Pre" 		pos:[ 40, 0] width:27 height:27 tooltip:"Previous image" border:off
	button btn1  "Next" 	pos:[ 80, 0] width:27 height:27 tooltip:"Next image" border:off

	button btn4  "Asgn" 	pos:[120, 0] width:27 height:27 tooltip:"Assign as bitmap texture to selection\n(Right Click for Settings)" border:off
	button btn20 "Ps" 		pos:[160, 0] width:27 height:27 tooltip:"Edit the bitmap texture image\n(Right Click for Settings)" border:off
	button btn25 "UnW" 	pos:[200, 0] width:27 height:27 tooltip:"Quick UnWrap UV" border:off
	button btn14 "Mat" 		pos:[240, 0] width:27 height:27 tooltip:"Rename Materials" border:off
	button btn15 "Rcol"		pos:[280, 0] width:27 height:27 tooltip:"Random Wirecolors\n(Right Click for Settings)" border:off

	button btn9  "Cpvt" 	pos:[320, 0] width:27 height:27 tooltip:"Center Pivot" border:off
	button btn10 "Px0" 		pos:[360, 0] width:27 height:27 tooltip:"Pivot at x=0" border:off
	button btn11 "Cp0" 		pos:[400, 0] width:27 height:27 tooltip:"Center Pivot and move to origin" border:off
	button btn26 "Pmin" 	pos:[440, 0] width:27 height:27 tooltip:"Pivot at bottom center" border:off
	button btn12 "RXf" 		pos:[480, 0] width:27 height:27 tooltip:"Reset Transform" border:off
	button btn19 "ASm" 	pos:[520, 0] width:27 height:27 tooltip:"AutoSmooth EPoly" border:off
	button btn24 "S+" 		pos:[560, 0] width:27 height:27 tooltip:"Incremental Save" border:off
	
	button btn13 "Lit" 		pos:[600, 0] width:27 height:27 tooltip:"Quick Lights" border:off
	button btn16 "Rall" 		pos:[640, 0] width:27 height:27 tooltip:"Render all views\n(Right Click for Settings)" border:off
	button btn17 "Logo" 	pos:[680, 0] width:27 height:27 tooltip:"Insert Logo\n(Right Click for Settings)" border:off

	button btn6  "1P" 		pos:[720, 0] width:27 height:27 tooltip:"Create One Polygon" border:off
	button btn7  "Cyl" 		pos:[760, 0] width:27 height:27 tooltip:"Create no cap cylinder\n(Right Click for Settings)" border:off
	button btn8  "Grnd" 	pos:[800, 0] width:27 height:27 tooltip:"Create Ground Plane\n(Right Click for Settings)" border:off
	button btn5  "Plne" 		pos:[840, 0] width:27 height:27 tooltip:"Create reference planes\n(Right Click for Settings)" border:off
	button btn27 "QSp" 	pos:[880, 0] width:27 height:27 tooltip:"QuadSphere" border:off
	button btn28 "QCy" 	pos:[920, 0] width:27 height:27 tooltip:"QuadCylinder" border:off
	
	button btn29 "MS?" 	pos:[960, 0] width:27 height:27 tooltip:"Open MaxScript Help\n(Right Click for Settings)" border:off
	button btn21 "Help" 	pos:[1000,0] width:27 height:27 tooltip:"Help" border:off
	button btn30 "S" 		pos:[1040,0] width:27 height:27 tooltip:"Save Indicator" border:off enabled:off

	timer saveclock "testClock" interval: 300000 
	
	on saveclock tick do
	(
-- 		print "saveme"
		if (getSaveRequired()) then 
		(
			if savered !=undefined then btn30.images = #(savered, undefined, 1, 1, 1, 1, 1)
		)
	)
	
	on OormiToolsRollout open do
	(
		GetOTConfig ()
		try
		(
			iconpath = getFilenamePath (getSourceFileName())
			otcontrols = OormiToolsRollout.controls
			for c=1 to (otcontrols.count-2) do
			(
				tb = openBitMap (iconpath + "Icons\\OT-Icons-"+ (formattedprint c format:"02u") + ".png")
				otcontrols[c].images = #(tb, undefined, 1, 1, 1, 1, 1)
			)
			savered = openBitMap (iconpath + "Icons\\OT-Icons-27.png")
			savegreen = openBitMap (iconpath + "Icons\\OT-Icons-28.png")
			btn30.images = #(savered, undefined, 1, 1, 1, 1, 1)
		)
		catch
		(
			print "OT Icons failed"
			messagebox "Icons were not found. Please ensure that you have a folder named Icons, containing the icon images, in the same folder as that of this script." title:"Error : Icons missing"
		)
	)

--	on btn100 pressed  do 
--	(
--		cui.UnRegisterDialogBar OormiToolsRollout
--		DestroyDialog OormiToolsRollout
--	)
	on btn29 pressed  do 
	(
		mshelplaunch()
	)
	on btn29 rightclick  do 
	(
		mshelppath = undefined
		mshelplaunch()
	)
	
	on btn28 pressed  do 
	( 
		try (destroydialog quadcylinderrollout)
		catch()
		createdialog quadcylinderrollout lockWidth:true lockHeight:true style:#(#style_toolwindow, #style_sysmenu, #style_resizing)
	)		

	on btn27 pressed  do 
	(
		try (destroydialog quadspheresettings)
		catch()
		createdialog quadspheresettings lockWidth:true lockHeight:true style:#(#style_toolwindow, #style_sysmenu, #style_resizing)
	)
	
	
	on btn26 pressed  do 
	( 
		with undo "Pivot Bottom" on 
		(
			for obj in selection do
			(
				CenterPivot obj
				obj.pivot = [obj.pos.x,obj.pos.y,obj.min.z]
			)
			if selection.count==0 then messagebox "Please select an object(s)."
		)
	)
	
	on btn25 pressed  do 
	( 
		with undo "UnWrap+" on 
		(
			ob = selection[1]
			if ob !=undefined then
			(
				if classof ob != Targetobject then
				(
					if superclassof ob == GeometryClass then
					(
						max modify mode
						addmodifier ob (Unwrap_UVW())
						wmod = ob.modifiers[#unwrap_uvw]
						wmod.unwrap5.setShowMapSeams off
						wmod.setTVSubObjectMode 3
						wmod.edit() 
						wmod.quick_map_preview = off
						wmod.setFreeFormMode on
						nmaps = wmod.numberMaps() 
						if nmaps>1 then 
						(
							wmod.unwrap.SetCurrentMap 2
							wmod.unwrap.DisplayMap on
						)
					)
					else messagebox "Unwarp cannot be applied to the selection. Please select geometry."
				)
				else messagebox "Unwarp cannot be applied to the selection. Please select geometry."
			)
			else messagebox "Please select something."
		)
	)
	
	on btn24 pressed  do 
	( --works for 99 increments only
		sf = maxfilepath+maxfilename
		if maxfilename.count<1 or maxfilepath.count<1 then sf = getMAXSaveFileName ()
		
		if sf!=undefined then
		(
			while (doesfileexist sf) do
			(
				s= getfilenamefile sf
				if s.count<2 then s=s+"00"
				n = substring s (s.count-1) 2
				n = n as integer
				if n==undefined then n=0
				num=true
				if n==0 then num=false
				n = ((n as integer) + 1) 
				if n<10 then n = "0"+(n as string)
				else n = n as string
				if num then s = substring s 1 (s.count-2)
				sf = maxfilepath + s+n+".max"
			)
			savemaxfile sf
			pushprompt ("Saved as " + sf)
		)
	)
	
	on btn21 pressed  do 
	(
		url = "http://oormi.in/software/oormitoolshelp-01.html"
		ShellLaunch url ""
	)

	on btn20 pressed  do 
	(
		Editimage()
	)
	on btn20 rightclick  do 
	(
		progpath = undefined
		Editimage()
	)
	
	on btn19 pressed  do 
	(
		undo "Autosmooth All" on
		(
			for obj in selection do
			(
				if classof obj == Editable_Poly then
				(
					autosmoothall obj
				)
				else messagebox (obj.name + " is not an Editable Poly !")
			)
		)
	)
	

	on btn17 pressed  do 
	(
		try (destroydialog logoset)
		catch()
		InLogo()
	)
	
	on btn17 rightclick  do 
	(
		try (destroydialog logoset)
		catch()
		dpos = GetDialogPos OormiToolsRollout
		createdialog Logoset pos:[dpos.x+680, dpos.y-80-27] lockWidth:true lockHeight:true style:#(#style_toolwindow, #style_sysmenu, #style_resizing)
	)
	
	on btn16 pressed  do 
	(
		try (destroydialog rallview)
		catch()
		RenderAllViews rallscale
	)
	
	on btn16 rightclick  do 
	(
		try (destroydialog rallview)
		catch()
		dpos = GetDialogPos OormiToolsRollout
		createdialog rallview pos:[dpos.x+640, dpos.y-25-27] lockWidth:true lockHeight:true style:#(#style_toolwindow, #style_sysmenu, #style_resizing)
	)
	
	on btn14 pressed  do RenameMat()
	
	on btn13 pressed  do 
	(
		undo "Quicklights" on 
		(
			QuickLight()
		)
	)
	
	on btn4 pressed  do 
	(
		try (destroydialog texset)
		catch()
		undo "Assign Texturemap" on
		(
			AssignTex b
		)
	)
	
	on btn4 rightclick  do 
	(
		try (destroydialog texset)
		catch()
		dpos = GetDialogPos OormiToolsRollout
		createdialog texset pos:[dpos.x+120, dpos.y-60-27] lockWidth:true lockHeight:true style:#(#style_toolwindow, #style_sysmenu, #style_resizing)
	)
	
	on btn12 pressed  do 
	(
		undo "Rx" on
		(
		for obj in selection do 
		(
			ResetXForm obj
			converttopoly obj
		)
		)
	)
	
	on btn11 pressed  do 
	(
		undo "Center Pivot and 0" on
		(
		for obj in selection do 
		(
			CenterPivot obj
			obj.pos=[0,0,0]
		)
		)
	)
	
	on btn10 pressed  do 
	(
		undo "Pivot at Y-axis" on
		(
		for obj in selection do 
		(
			obj.pivot.x=0
		)
		)
	)
	
	on btn9 pressed  do 
	(
		undo "Center Pivot" on
		(
		for obj in selection do (CenterPivot obj)
		)
	)
	
	on btn8 pressed  do 
	(
		try (destroydialog groundcol)
		catch()
		undo "Ground" on
		(
		p = plane length:200 width:200 lengthsegs:1 widthsegs:1
		p.pos = [0,0,0]
		p.name = uniquename "Ground"
		p.mat = Standardmaterial()
		p.mat.opacitymap = Gradient()
		p.mat.opacitymap.gradientType = 1
		p.mat.opacitymap.color2 = color 255 255 255
		p.mat.opacitymap.color2Pos = 0.7
		p.mat.diffuse = gcolor
		showTextureMap p.mat on
		)
	)
	
	on btn8 rightclick  do 
	(
		try (destroydialog groundcol)
		catch()
		dpos = GetDialogPos OormiToolsRollout
		createdialog groundcol pos:[dpos.x+800, dpos.y-25-27] lockWidth:true lockHeight:true style:#(#style_toolwindow, #style_sysmenu, #style_resizing)
	)
	
	on btn7 pressed  do 
	(
		try (destroydialog cylset)
		catch()
		undo "Nocap Cylinder" on
		(
		c = cylinder radius:10 height:100 heightsegs:1 capsegs:1 sides:cylsides isSelected:on
		converttopoly c
		polyOp.deleteFaces c #((cylsides +1),(cylsides +2))
		)
	)
	
	on btn7 rightclick  do 
	(
		try (destroydialog cylset)
		catch()
		dpos = GetDialogPos OormiToolsRollout
		createdialog cylset pos:[dpos.x+760, dpos.y-25-27] lockWidth:true lockHeight:true style:#(#style_toolwindow, #style_sysmenu, #style_resizing)
	)
	
	on btn15 pressed  do 
	(
		for obj in selection do
		(
			obj.wirecolor = random (color rw1 rw1 rw1) (color rw2 rw2 rw2) 
		)
		if selection.count<1 then messagebox "Please select some object(s)"
	)
	on btn15 rightclick  do 
	(
		try (destroydialog rwset)
		catch()
		dpos = GetDialogPos OormiToolsRollout
		createdialog rwset pos:[dpos.x+280, dpos.y-130-27] lockWidth:true lockHeight:true style:#(#style_toolwindow, #style_sysmenu, #style_resizing)
	)
	
	on btn6 pressed  do 
	(
		undo "Create One Poly" on
		(
			p = plane length:20 width:20 lengthsegs:1 widthsegs:1
			p.pos = [0,0,0]
			rotate p (Eulerangles 90 0 0)
			ResetXForm p
			converttopoly p
			select p
			max modify mode
		)
	)
	
	on btn5 pressed  do 
	(
		isvalid = false
		if b == undefined then 
		(
			b = selectbitmap()
			isvalid = true
		)
		if b != undefined then 
		(
			undo "Reference Plane" on
			(
				p=plane width:b.width length:b.height lengthsegs:1 widthsegs:1
				select p
				AssignTex b
				p.mat.selfIllumAmount = rpselfillum
				rotate p (Eulerangles 90 0 0)
				if rpcross then
				(
					q=copy p
					rotate q (Eulerangles 0 0 90)
					ResetXForm p
					ResetXForm q
					converttopoly p
					p.attach q q
				)
				p.name = uniqueName "ReferencePlane"
				p.renderable = rprender
				if isvalid then b = undefined 
			)
		)
	)
	on btn5 rightclick  do 
	(
		try (destroydialog rpset)
		catch()
		dpos = GetDialogPos OormiToolsRollout
		createdialog rpset pos:[dpos.x+840, dpos.y-100-27] lockWidth:true lockHeight:true style:#(#style_toolwindow, #style_sysmenu, #style_resizing)
	)
	
	on btn1 pressed  do 
	(
		if b != undefined then 
		(
			close b
			undisplay b
			
			if index <=count then
			(
			index = index + 1
			if index > count then index = 1
			b = openbitmap alli[index]
			display b
			)
		)
	)	--load next image
	
	
	on btn2 pressed  do 
	(
		if b != undefined then 
		(
			close b
			undisplay b
			if index >=1 then
			(
				index = index - 1
				if index < 1 then index = count
				b = openbitmap alli[index]
				display b
			)
		)
	)	--load previous image
	
	
	on btn3 pressed  do 
	(
		fb = selectbitmap() --getOpenFileName caption:"Open An Image File:"
		f = undefined
		
		if fb !=undefined then f = fb.filename
		if f != undefined then
		(
			ext = tolower(getFilenameType f)
			if not ((ext == ".jpg") or (ext == ".jpeg") or (ext == ".tif") or (ext == ".gif")  or (ext == ".bmp") or (ext == ".tga") or (ext == ".png") or (ext == ".dds")) then
			(
				if ext == ".ifl" then RAMPlayer f ""
				else res = shelllaunch f ""
				
			)
			else
			(
				--else
				(
					b=undefined
					try 
					(
					b = openBitMap f
					)
					catch 
					(
					messagebox "Failed to open the file" title:"OormiToolsRollout Error"
					)
					
					
					if b != undefined then
					(
						display b
						
						pf = getFilenamePath f
						alljpg = getFiles (pf + "*.jpg")
						alltif = getFiles (pf + "*.tif")
						allgif = getFiles (pf + "*.gif")
						allbmp = getFiles (pf + "*.bmp")
						alltga = getFiles (pf + "*.tga")
						allpng = getFiles (pf + "*.png")
						alldds = getFiles (pf + "*.dds")
						
						
						alli = alljpg + alltif + allgif + allbmp + alltga + allpng + alldds
						count = alli.count
					)
					else (messagebox "Failed to display the image" title:"OormiToolsRollout Error")
				)
			)
		)
	)	--load image
	
	on btn3 rightclick do
	(
		try(undisplay b);catch()
		b=undefined
		alli = #()
	)--clear images
	
	on OormiToolsRollout close do
	(
		if b != undefined then
		(
			undisplay b
			close b
		)
		callbacks.removeScripts id:#oormisavecallback
	)
	
)--roll


Createdialog OormiToolsRollout --lockWidth:true lockHeight:true style:#(#style_toolwindow, #style_sysmenu, #style_resizing)
cui.RegisterDialogBar OormiToolsRollout style:#(#cui_dock_horz, #cui_floatable, #cui_handles, #cui_max_sized)
cui.DockDialogBar OormiToolsRollout #cui_dock_bottom

callbacks.removeScripts id:#oormisavecallback
callbacks.addScript #filePreSaveProcess "OormiSaveNotification()" id:#oormisavecallback

)--main
